# BDM register

#	Copyright (C) 2003 Embedded CL S.A.
#
#	This program is free software; you can redistribute it and/or
#	modify it under the terms of the GNU General Public License
#	as published by the Free Software Foundation; either version 2
#	of the License, or (at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

# control
CACR = 0x002
ACR0 = 0x004
ACR1 = 0x005
ACR2 = 0x006
ACR3 = 0x007
VBR = 0x801
MACSR = 0x804
MASK = 0x805
ACC = 0x806
SR = 0x80e
PC = 0x80f
RAMBAR0 = 0xc04
RAMBAR1 = 0xc05
MBAR = 0xc0f

# debug
CSR = 0x00
BAAR = 0x05
AATR = 0x06
TDR = 0x07
PBR = 0x08
PBMR = 0x09
ABHR = 0x0c
ABLR = 0x0d
DBR = 0x0e
DBMR = 0x0f
AATR1 = 0x16
XTDR = 0x17
PBR1 = 0x18
PBR2 = 0x1a
PBR3 = 0x1b
ABHR1 = 0x1c
ABLR1 = 0x1d
DBR1 = 0x1e
DBMR1 = 0x1f


class bdmreg:
	bit = { }

	def __init__(self, a, v=0):
		self.address = a # location
		self.value = v # value

	def __int__(self): return self.value

	def __hex__(self): return hex(self.value)

	def __getitem__(self, k):
		if type(k) is slice: return (self.value>>k.stop) & ((1<<(k.start-k.stop+1))-1)
		elif type(k) is tuple: return (self.value>>k[1]) & ((1<<(k[0]-k[1]+1))-1)
		else: return (self.value>>k) & 0x1

#	def __setitem__(self, k, v):

	def __getattr__(self, k):
		if self.bit.has_key(k):
			b = self.bit[k]
			if type(b) is tuple: return (self.value>>b[1]) & ((1<<(b[0]-b[1]+1))-1)
			else: return (self.value>>b) & 0x1
		else: return self.__dict__[k]

	def __setattr__(self, k, v):
#		if k == 'value':
#			self.__dict__[k] = v
#			for i in self.bit:
#				setattr(self, i, self[self.bit[i]]) # calls getitem
		if self.bit.has_key(k):
			b = self.bit[k]
			if type(b) is tuple:
				m = (1<<(b[0]-b[1]+1))-1
				self.value &= ~(m<<b[1])
				self.value |= (v & m)<<b[1]
			else:
				self.value &= ~(1<<b)
				self.value |= (v & 0x1)<<b
		else: self.__dict__[k] = v


class csr(bdmreg):
	bit = {
		'BSTAT': (31,28),
		'FOF': 27,
		'TRG': 26,
		'HALT': 25,
		'BKPT': 24,
		'HRL': (23, 20),
		'BKD': 18,
		'PCD': 17,
		'IPW': 16,
		'MAP': 15,
		'TRC': 14,
		'EMU': 13,
		'DDC': (12,11),
		'UHE': 10,
		'BTB': (9,8),
		'NPL': 6,
		'SSM': 4
	}

	def __init__(self, v = 0):
		bdmreg.__init__(self, CSR, v)
