#ifndef PARPORT_H
#define PARPORT_H

/*
	Copyright (C) 2003 Embedded CL S.A.

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


/* Defines */
/*
<:output, >:input

<1 /c0 /strobe
<2 d0 data0
<3 d1 data1
<4 d2 data2
<5 d3 data3
<6 d4 data4
<7 d5 data5
<8 d6 data6
<9 d7 data7
>10 s6 acknowledge
>11 /s7 /busy
>12 s5 paper_error
>13 s4 select
<14 /c1 /autofeed
>15 s3 error
<16 c2 init
<17 /c3 /select_in
18-25 GND

s0, s1 -
s2 /irq

c4 ack_irq_enable
c5 bidirectional
c6, c7 -

Base+0 RW = D[7:0]
Base+1 WO = nBsy nAck PE Sl nErr nIRQ - -
Base+2 RW = - - D IQ nSI nIn nAF nSt

Status
nBsy[I]: Printer busy
nAck[I]: Printer acknowledge
PE[I]: Out of paper error
Sl[I]: Device selected
nErr[I]: Device error
nIRQ[I]: Printer ack active (PS/2 or bidirectional)

Control
D[O]: PS/2 data direction (output=0, input=1) write-only
IQ[O]: IRQ enable
nSI[O]: Select input (online=1)
nIn[O]: Initialize printer
nAF[O]: Autofeed (add linefeed=1)
nSt[O]: Strobe (data available=1), inverted
*/
#define DEFAULT_PORT 0x0378
#define DATA_PORT 0 // data
#define STATUS_PORT 1 // status input
#define CONTROL_PORT 2 // control output

#define D0 0
#define D1 1
#define D2 2
#define D3 3
#define D4 4
#define D5 5
#define D6 6
#define D7 7

#define nIRQ 2
#define nERROR 3
#define SLCT 4
#define PE 5
#define nACK 6
#define nBUSY 7

#define nSTROBE 0
#define nAUTOFEED 1
#define nINIT 2
#define nSLCTIN 3
#define IRQEN 4
#define DIRECTION 5

#endif // PARPORT_H
